freeslot("sfx_lap", "sfx_lapen", "sfx_scren")
local lap = 0 
local laptimer = -1
local enterportal = false

addHook("MobjSpawn",function(mo)
	if (mo.type == MT_PIZZAPORTAL)
	and multiplayer
		P_RemoveMobj(mo)  
	end
end)


addHook("MapLoad", function()
	laptimer= -1
	lap = 0
end)
addHook("PlayerSpawn", function(player)
	lap = 0
	player.ringtimer = 0
	laptimer= -1
end)

addHook("TouchSpecial", function(special, toucher)
	if special.type == MT_PIZZAPORTAL --The touched object is a Pizza Portal
	and toucher.health > 0 --The Lapper is alive
	and enterportal == false -- The Lapper is not already entering a portal
		enterportal = true
	end
	if special.type == MT_PIZZAPORTAL --The touched object is a Pizza Portal
	return true
	end
end)

addHook("PlayerThink", function(player)
	if enterportal == true -- Checks if you have entered a pizza portal
		P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT) -- Stops your movement
		P_SetObjectMomZ(player.mo, 0*FRACUNIT, false) -- Stops your movement
		P_TeleportMove(player.mo, (mapheaderinfo[gamemap].lapspawnx)*FRACUNIT, (mapheaderinfo[gamemap].lapspawny)*FRACUNIT, (mapheaderinfo[gamemap].lapspawnz)*FRACUNIT+(90*FRACUNIT)) -- Moves the player to the lap spawn set in MAINCFG
		player.mo.angle = (mapheaderinfo[gamemap].lapspawnangle)
		S_StartSound(player.mo, sfx_lap) -- Sounds for the Pizza Portal
		S_StartSound(player.mo, sfx_lapen) -- Sounds for the Pizza Portal
		S_StartSound(player.mo, sfx_scren) -- Sounds for the Pizza Portal
		if lap == 0 -- Checks if you have not started a lap.
		laptimer = (mapheaderinfo[gamemap].laptime) * TICRATE -- Set's the time for the lap.
		end
		lap = $+1 -- Adds one to the lap counter.
		P_AddPlayerScore(player, 3000) -- Adds 3000 score per lap.
		P_GivePlayerRings(player, 10) -- Adds 10 rings per lap.
		enterportal = false
	end
	if laptimer <= 0 and lap > 0 -- Checks if you have no time left on the lap timer.
	and (leveltime % TICRATE == 0)
		player.ringtimer = $ + 1
		if (player.ringtimer == 5)
			P_GivePlayerRings(player, -5)
			player.ringtimer = 0
		end
		if player.rings <= 0
			P_DamageMobj(player.mo, nil, nil, nil, DMG_INSTAKILL)
		end
	end
	if laptimer > -1 and not player.exiting
		laptimer = $-1
	end
	if player.rings < 0
	player.rings = 0
	end
	if lap > 0 and not (player.powers[pw_extralife] or player.powers[pw_sneakers] or player.powers[pw_invulnerability] or player.powers[pw_super]) and not player.exiting
		if (mapheaderinfo[gamemap].lapmusic) == nil -- If no custom lap music is present...
			S_ChangeMusic("DESER", true, player) -- Use The Death I Deservioli.
		else
			S_ChangeMusic((mapheaderinfo[gamemap].lapmusic), true, player) -- Change to custom lap music
		end
	end
end)

local function LAPTIME(v, player) -- Kudos goes to TheLastKitchenGun for originaly making the hud.
	if laptimer >= 0
	v.drawString(140, 20, "\x82"+G_TicsToMinutes(laptimer)+" : "+G_TicsToSeconds(laptimer)+"", V_YELLOWMAP|V_SNAPTOTOP)
	v.drawString(190, 20, "\x82"+"Lap: "+lap, V_PURPLEMAP|V_SNAPTOTOP)
	end
	if laptimer == -1 and lap > 0
	v.drawString(140, 20, "\x82"+"0"+" : "+"0"+"", V_REDMAP|V_SNAPTOTOP)
	v.drawString(190, 20, "\x82"+"Lap: "+lap, V_REDMAP|V_SNAPTOTOP)
	end
end
hud.add(LAPTIME, "game")